package controller;

import gui.EditNote;
import gui.MainGuiFrame;
import gui.ShowNote;
import gui.TabContent;

import java.awt.event.ActionEvent;
import java.util.ResourceBundle;

import javax.swing.Action;

import model.Note;

public class EditAction extends AbstractNoteAction{

	private MainGuiFrame mainGui;
	private ShowNote showNote;
	private Note note;
	
	public EditAction(){
		super("edit");
	}
	
	public void setMainGuiReference(MainGuiFrame mainGui) {
		this.mainGui = mainGui;
	}
	
	public void setTabContentReference(ShowNote tabOld){
		showNote = tabOld;
	}
	
	public void setNoteReference(Note note){
		this.note = note;
	}
	
	public void actionPerformed(ActionEvent ae) {
		EditNote editNote;
		mainGui.removeTab(showNote);
		editNote = new EditNote(mainGui, note);
		editNote.setContent();
	}
}
