package sql;

import java.util.Collection;

import model.Category;
import model.Note;
import model.SearchCriteria;

public class SQLImplementation implements SQL {

	private static SQL sqlInstance;
	
	private SQLImplementation(){
		
	}
	
	public static SQL getInstance(){
		
		if(sqlInstance == null){
			sqlInstance = new SQLImplementation();
		}	
			return sqlInstance;
	}


	public boolean createNote(Note n) {
		return false;
	}

	public boolean deleteNote(Note n, boolean myBoolean) {
		DeleteDAO delDAO = new DeleteDAO();
		return delDAO.deleteNote(n, myBoolean);
	}

	public boolean saveNote(Note n) {
		SaveDAO saDAO = new SaveDAO();
		try{
			return saDAO.saveNote(n);
		}catch(Exception ex){
			return false;
		}
		}

	public Collection searchNote(SearchCriteria s) {
		SearchDAO seDAO = new SearchDAO();
		return seDAO.searchNote(s);
	}

	public Category getRootCategory() {
		CategoryDAO caDAO = new CategoryDAO();
		return caDAO.getRootCategory();
	}
	


}
