package sql;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;

import model.Note;

public class SaveDAO extends DAO{

	final static String SQL_DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";
	int authorID = 0;
	int noteid = 0;
	boolean isUserOk = true;

	public boolean saveNote(Note n){

		String date = formatDate(new Date());

		try{		
			stmt = c.createStatement();
			if(n.getDBID() == 0){
				setMaxNoteversion();
			}

			while(isUserOk){
				verifyAuthorID(n);
			}
			return commitQuery(n, date);
		}
		catch(SQLException ex){
			return errorQuery(c, ex);	
		}
		finally{
			ref.putConnection("db_notizverwaltung", c);
		}
	}

	private boolean commitQuery(Note n, String date) throws SQLException {
		stmt.executeUpdate("INSERT INTO noteversion (NoteID, VersionID, Title, Author, Text, Date, Keyword) VALUES('"+ noteid+"' ,'"+n.getVersionID()+"' ,'"+ n.getTitle() +"' ,'"+ authorID +"' ,'"+ n.getFullText() +"' ,'"+ date +"', '"+ n.getKeyword() +"')");
		lastCommitState(c);
		return true;
	}

	private void setMaxNoteversion() throws SQLException {
		String newSaveStatement ="SELECT MAX(NoteID) FROM noteversion";
		ResultSet res = stmt.executeQuery(newSaveStatement);
		while(res.next()){
			noteid = res.getInt("MAX(NoteID)");
			noteid ++;
		}
	}

	private void verifyAuthorID(Note n) throws SQLException {
		ResultSet authorResult = stmt.executeQuery("SELECT UserID FROM user WHERE Nickname=\"" + n.getAuthor() +"\"");
		if(authorResult.next() == false)
		{
			stmt.executeUpdate("INSERT INTO user (Nickname, Password) VALUES('" + n.getAuthor() +"', '"+n.getAuthor()+"')");
		}
		else{
			authorID = authorResult.getInt("UserID");
			isUserOk = false;
		}

	}

	public static String formatDate(Date d) {
		if(null == d){
			return null;
		}

		SimpleDateFormat sd = new SimpleDateFormat(SQL_DATE_FORMAT);
		String date = sd.format(d);
		return date;


	}

	public static void main(String[] args) {
		SaveDAO dao = new SaveDAO();
//		dao.saveNote(21, 1, "blasgfhdfhddasdah", "Grenacher", "flame", "awp lameassfgsdfgdr ^^");
	}
}
