package controller;

import gui.CreateNote;
import gui.MainGuiFrame;

import java.awt.event.ActionEvent;
import java.util.ResourceBundle;
import javax.swing.Action;

public class NewNoteAction extends AbstractNoteAction{

	CreateNote createNote;
	MainGuiFrame mainGui;
	
	public NewNoteAction(){
		super("newNote", true);
	}
	
	public void setCreateNote(CreateNote cn){
		createNote = cn;
	}
	
	public void setMainGui(MainGuiFrame mg){
		mainGui = mg;
	}
	
	public void actionPerformed(ActionEvent ae) {
		mainGui.setActiveTab(createNote);
	}

}
