package controller;

import gui.SearchResultNote;
import gui.ShowNote;

import java.awt.event.ActionEvent;
import java.util.ArrayList;

import model.Note;

public class OpenAction extends AbstractNoteAction{

	private SearchResultNote mySearchResultNote;

	public OpenAction(){
		super("open");
	}

	public void actionPerformed(ActionEvent ae) {
	ArrayList<Integer> myIndex = mySearchResultNote.getIndexes();
		
//		System.out.println("Size of myIndex" +myIndex.size());

		for (int i = 0; i < myIndex.size(); i++) {
			int numberFromMyIndex = myIndex.get(i);
			Note myNote = mySearchResultNote.getNoteVersionObject(numberFromMyIndex);
			new ShowNote(mySearchResultNote.getMainGuiReference(), myNote);
		}
	}

	public void setSearchResultNoteReference(SearchResultNote note) {
		mySearchResultNote = note;	

	}

}
