package sql;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import model.Category;

public class CategoryDAO extends DAO{

	public static final int ROOT_ID = 1;


	private void addChildren(Category cat) {
		ResultSet rs = getResultSet("SELECT * FROM category WHERE ParentID = " + cat.getDbID() + " ");
		try {
			while(rs.next()){
				newCategory(cat, rs);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	private void newCategory(Category cat, ResultSet rs) throws SQLException {
		Category actCategory = new Category();
		actCategory.setName(rs.getString("Name"));
		actCategory.setDbID(rs.getInt("CategoryID"));
		actCategory.setParentCategory(cat);
		cat.addChild(actCategory);
		addChildren(actCategory);
	}

	private Category readRootCategoryFromDB() {
		Category root = new Category();
		ResultSet rs = getResultSet("SELECT * FROM category WHERE CategoryID= " +   ROOT_ID + " ");
		try {
			rs.next();
			root.setName(rs.getString("Name"));
			root.setDbID(ROOT_ID);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return root;
	}

	private ResultSet getResultSet(String sql) {
		ResultSet rs;
		try{		
			stmt = c.createStatement();
			rs = stmt.executeQuery(sql);
			return rs;
		} catch(SQLException ex){
			errorQuery(c, ex);
			return null;
		}
		finally{
			ref.putConnection("db_notizverwaltung", c);
		}
	}

	public Category getRootCategory() {
		Category root = readRootCategoryFromDB();
		addChildren(root);
		
		return root;
	}
}

